/*

  This is a part of the Project Frontier's Source code.

  Copyright (C) 1997-98 Francis Gastellu
                    aka Lone Runner/Aegis

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/

#ifndef __DEBUG_H
#define __DEBUG_H

#include "..\lang\vfs.h"

#ifdef __cplusplus
extern "C" {
#endif

	void debuggerInit(void);
	void debuggerReset(void);

	void debuggerRun(void);
	void debuggerLoadSymbols(vfs_file *, long offset);
	void debuggerStep(void);

	void runToDebugScreen(void);
	void debugToRunScreen(void);

	void debuggerMain(void);
	void debuggerInitScreen(void);
	void updateFileViewer(int keepFocus);
	void debuggerEndSession(void);
	int debuggerOffsetToLine(unsigned int offset);
	int debuggerLineToOffset(unsigned int line);
	void debugReadline(char *buffer, int size, int line, FILE *file);

	void debuggerAddBreakPoint(int line);
	void debuggerRemoveBreakPoint(int line);
	int debuggerIsBreakPoint(int line);

	void debuggerRemoveWatch(int varnum);
	void updateWatches(void);
	void debuggerAddWatch(char *name);

	void printstr(int left, int top, char str[], int maxlen, int curs);
	int editfield(int left, int top, char str[], int maxlen);
	void messagebox(char *msg, char *title);
	void openbox(int left, int top, int right, int bot, char titre[]);
	void updateCursor(void);


#ifdef __cplusplus
}
#endif

extern int far traceOver;
extern int far fullRun;
extern int far nextBreak;
extern int far globalQuitDebugger;
extern int far debuggerEnabled;
extern int far quitLoop;

#endif